package com.example.zaquiel.rodriguezz_u4;

import android.app.Activity;
import android.app.Application;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Path;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.PathShape;
import android.graphics.drawable.shapes.RectShape;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.media.SoundPool;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.AttributeSet;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;

import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;

import java.util.List;
import java.util.Vector;

/**
 * Created by zaquiel on 13/09/15.
 */
public class VistaJuego extends View implements SensorEventListener {

    private Activity padre;
    public void setPadre(Activity padre) {
        this.padre = padre;
    }
    private Imagen imagen;

    public int variable1 = 4;
    public int variable2 = 8;

    private int puntuacion = 0;
    private String numeroNave = "2";


    private void salir() {
        Bundle bundle = new Bundle();
        bundle.putInt("puntuacion", puntuacion);
        Intent intent = new Intent();
        intent.putExtras(bundle);
        padre.setResult(Activity.RESULT_OK, intent);
        padre.finish();
    }

    // //// MULTIMEDIA //////
    SoundPool soundPool;
    int idDisparo, idExplosion;

    // VALORES SENSORES ///////////
    SensorManager sm;

    MediaPlayer mpDisparo, mpExplosion;

    private boolean sensorActivo = false;

    public Juego juego;


    // ////MISIL //////
    private Grafico misil;
    private static int PASO_VELOCIDAD_MISIL = 12;
    private boolean misilActivo = false ;
    private int tiempoMisil;

    // //// THREAD Y TIEMPO //////
// Thread encargado de procesar el juego
    private ThreadJuego thread = new ThreadJuego();
    // Cada cuanto queremos procesar cambios (ms)
    private static int PERIODO_PROCESO = 50;
    // Cuando se realizó el último proceso
    private long ultimoProceso = 0;

    // //// ASTEROIDES //////
    private Vector<Grafico> asteroides; // Vector con los Asteroides
    private int numAsteroides = 5; // Número inicial de asteroides
    private int numFragmentos = 3; // Fragmentos en que se divide

    // //// NAVE //////
    private Grafico nave; // Gráfico de la nave
    private int giroNave; // Incremento de dirección
    private double aceleracionNave; // aumento de velocidad
    private static int MAX_VELOCIDAD_NAVE = 20;
    // Incremento estándar de giro y aceleración
    private static final int PASO_GIRO_NAVE = 5;
    private static float PASO_ACELERACION_NAVE = 0.5f;


    public VistaJuego(Context context, AttributeSet attrs){


        super(context, attrs);

        Drawable drawableNave, drawableAsteroide, drawableMisil;

        SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(getContext());
        if (pref.getString("graficos", "1").equals("0")){
            Path pathAsteroide = new Path();
            pathAsteroide.moveTo((float) 0.3, (float) 0.0);
            pathAsteroide.lineTo((float) 0.6, (float) 0.0);
            pathAsteroide.lineTo((float) 0.6, (float) 0.3);
            pathAsteroide.lineTo((float)0.8, (float)0.2);
            pathAsteroide.lineTo((float)1.0, (float)0.4);
            pathAsteroide.lineTo((float)0.8, (float)0.6);
            pathAsteroide.lineTo((float) 0.9, (float) 0.9);
            pathAsteroide.lineTo((float)0.8, (float)1.0);
            pathAsteroide.lineTo((float)0.4, (float)1.0);
            pathAsteroide.lineTo((float)0.0, (float)0.6);
            pathAsteroide.lineTo((float) 0.0, (float) 0.2);
            pathAsteroide.lineTo((float) 0.3, (float) 0.0);
            ShapeDrawable dAsteroide= new ShapeDrawable(new PathShape(pathAsteroide, 1, 1));
            dAsteroide.getPaint().setColor(Color.WHITE);
            dAsteroide.getPaint().setStyle(Paint.Style.STROKE);
            dAsteroide.setIntrinsicWidth(50);
            dAsteroide.setIntrinsicHeight(50);
            drawableAsteroide = dAsteroide;
            setBackgroundColor(Color.BLACK);

            Path pathNave = new Path();
            pathNave.moveTo((float) 0.0, (float) 0.0);
            pathNave.lineTo((float) 1.0, (float) 0.5);
            pathNave.lineTo((float) 0.0, (float) 1.0);
            pathNave.lineTo((float) 0.0, (float) 0.0);
            ShapeDrawable dNave = new ShapeDrawable(new PathShape(pathNave,1, 1));
            dNave.getPaint().setColor(Color.WHITE);
            dNave.getPaint().setStyle(Paint.Style.STROKE);
            dNave.setIntrinsicWidth(20);
            dNave.setIntrinsicHeight(15);
            drawableNave = dNave;
            setBackgroundColor(Color.BLACK);
            setLayerType(View.LAYER_TYPE_SOFTWARE, null);

        }else {
            //drawableAsteroide = context.getResources().getDrawable(R.drawable.asteroide02);

            if (pref.getString("Asteroides", "1").equals("1"))
            {
                drawableAsteroide = context.getResources().getDrawable(R.drawable.asteroide01);
                variable1 = 6;
                variable2 = 10;
            }
            else
            {
                if (pref.getString("Asteroides", "2").equals("2"))
                {
                    drawableAsteroide = context.getResources().getDrawable(R.drawable.asteroide02);
                    variable1 = 8;
                    variable2 = 12;
                }
                else
                {
                    if (pref.getString("Asteroides", "3").equals("3"))
                    {
                        drawableAsteroide = context.getResources().getDrawable(R.drawable.asteroide03);
                        variable1 = 10;
                        variable2 = 14;
                    }
                    else
                    {
                        if (pref.getString("Asteroides", "4").equals("4"))
                        {
                            drawableAsteroide = context.getResources().getDrawable(R.drawable.asteroide04);
                            variable1 = 12;
                            variable2 = 16;
                        }
                        else
                        {
                            drawableAsteroide = context.getResources().getDrawable(R.drawable.asteroide1);
                        }
                    }
                }
            }


            /*numeroNave = pref.getString("tiposNaves", "0");

            if (!numeroNave.equals("0")){
                switch(numeroNave)
                {
                    case "1":drawableNave = context.getResources().getDrawable(R.drawable.nave1);break;
                    case "2":drawableNave = context.getResources().getDrawable(R.drawable.nave2);break;
                    case "3":drawableNave = context.getResources().getDrawable(R.drawable.nave3);break;
                    case "4":drawableNave = context.getResources().getDrawable(R.drawable.nave4);break;
                    default:drawableNave = context.getResources().getDrawable(R.drawable.nave);break;
                }
            }
            else{drawableNave = context.getResources().getDrawable(R.drawable.nave);}*/
            if (pref.getString("Naves", "1").equals("1"))
            {
                drawableNave = context.getResources().getDrawable(R.drawable.nave1);
                MAX_VELOCIDAD_NAVE = 30;
                PASO_ACELERACION_NAVE = 1.5f;
            }
            else
            {
                if (pref.getString("Naves", "2").equals("2"))
                {
                    drawableNave = context.getResources().getDrawable(R.drawable.nave2);
                    MAX_VELOCIDAD_NAVE = 40;
                    PASO_ACELERACION_NAVE = 2.5f;
                }
                else
                {
                    if (pref.getString("Naves", "3").equals("3"))
                    {
                        drawableNave = context.getResources().getDrawable(R.drawable.nave3);
                        MAX_VELOCIDAD_NAVE = 50;
                        PASO_ACELERACION_NAVE = 3.5f;
                    }
                    else
                    {
                        if (pref.getString("Naves", "4").equals("4"))
                        {
                            drawableNave = context.getResources().getDrawable(R.drawable.nave4);
                            MAX_VELOCIDAD_NAVE = 60;
                            PASO_ACELERACION_NAVE = 4.5f;
                        }
                        else
                        {
                            drawableNave = context.getResources().getDrawable(R.drawable.nave);
                        }
                    }
                }
            }




            //drawableNave = context.getResources().getDrawable(R.drawable.nave);

            setLayerType(View.LAYER_TYPE_HARDWARE, null);
        }

        asteroides = new Vector<Grafico>();
        for (int i = 0; i <numAsteroides; i++){
            Grafico asteroide = new Grafico(this, drawableAsteroide);
            asteroide.setIncY(Math.random()*variable1-2);
            asteroide.setIncX(Math.random() * variable1 - 2);
            asteroide.setAngulo((int) (Math.random() * 360));
            asteroide.setRotacion((int) (Math.random() * variable2 - 4));
            asteroides.add(asteroide);
        }

        nave = new Grafico(this, drawableNave);

        SensorManager mSensorManager = (SensorManager)
                context.getSystemService(Context.SENSOR_SERVICE);
        List<Sensor> listSensors = mSensorManager.getSensorList(
                Sensor.TYPE_ORIENTATION);
        if (!listSensors.isEmpty()) {
            Sensor orientationSensor = listSensors.get(0);
            mSensorManager.registerListener(this, orientationSensor,SensorManager.SENSOR_DELAY_GAME);
        }

        ShapeDrawable dMisil = new ShapeDrawable(new RectShape());
        dMisil.getPaint().setColor(Color.WHITE);
        dMisil.getPaint().setStyle(Paint.Style.STROKE);
        dMisil.setIntrinsicWidth(15);
        dMisil.setIntrinsicHeight(3);


        drawableMisil = dMisil;
        misil = new Grafico(this,drawableMisil);


        sm = (SensorManager) context.getSystemService(Context.SENSOR_SERVICE);
        activarSensores();

        mpDisparo = MediaPlayer.create(context, R.raw.disparo);
        mpExplosion = MediaPlayer.create(context, R.raw.explosion);

        soundPool = new SoundPool( 5, AudioManager.STREAM_MUSIC , 0);
        idDisparo = soundPool.load(context, R.raw.disparo, 0);
        idExplosion = soundPool.load(context, R.raw.explosion, 0);
    }

    protected synchronized void actualizaFisica() {
        long ahora = System.currentTimeMillis();
        if (ultimoProceso + PERIODO_PROCESO > ahora) {
            return;
// Salir si el período de proceso no se ha cumplido.
        }
// Para una ejecución en tiempo real calculamos retardo
        double retardo = (ahora - ultimoProceso) / PERIODO_PROCESO;
        ultimoProceso = ahora; // Para la próxima vez
// Actualizamos velocidad y dirección de la nave a partir de
// giroNave y aceleracionNave (según la entrada del jugador)
        nave.setAngulo((int) (nave.getAngulo() + giroNave * retardo));
        double nIncX = nave.getIncX() + aceleracionNave *
                Math.cos(Math.toRadians(nave.getAngulo())) * retardo;
        double nIncY = nave.getIncY() + aceleracionNave *
                Math.sin(Math.toRadians(nave.getAngulo())) * retardo;
// Actualizamos si el módulo de la velocidad no excede el máximo
        if (Math.hypot(nIncX,nIncY) <= MAX_VELOCIDAD_NAVE ){
            nave.setIncX(nIncX);
            nave.setIncY(nIncY);
        }
        nave.incrementaPos(retardo); // Actualizamos posición
        for (Grafico asteroide : asteroides) {
            asteroide.incrementaPos(retardo);
        }

        // Actualizamos posición de misil
        if (misilActivo) {
            misil.incrementaPos(retardo);
            tiempoMisil-=retardo;
            if (tiempoMisil < 0) {
                misilActivo = false;
            } else {
                for (int i = 0; i < asteroides.size(); i++)
                    if (misil.verificaColision(asteroides.elementAt(i))) {
                        destruyeAsteroide(i);
                        break;
                    }
            }
        }
        for (Grafico asteroide : asteroides) {
            if (asteroide.verificaColision(nave)) {
                salir();
            }
        }
    }

    public void numeroNave(String numNave)
    {
        numeroNave = numNave;
    }

    @Override
    public boolean onKeyDown(int codigoTecla, KeyEvent evento) {
        super.onKeyDown(codigoTecla, evento);
        // Suponemos que vamos a procesar la pulsación
        boolean procesada = true;
        switch (codigoTecla) {
            case KeyEvent.KEYCODE_DPAD_UP:
                aceleracionNave = +PASO_ACELERACION_NAVE;
                break;
            case KeyEvent.KEYCODE_DPAD_LEFT:
                giroNave = -PASO_GIRO_NAVE;
                break;
            case KeyEvent.KEYCODE_DPAD_RIGHT:
                giroNave = +PASO_GIRO_NAVE;
                break;
            case KeyEvent.KEYCODE_DPAD_CENTER:
            case KeyEvent.KEYCODE_ENTER:
                activaMisil();
                break;
            default:
// Si estamos aquí, no hay pulsación que nos interese
                procesada = false;
                break;
        }
        return procesada;
    }

    class ThreadJuego extends Thread {
        private boolean pausa,corriendo;
        public synchronized void pausar() {
            pausa = true;
        }
        public synchronized void reanudar() {
            pausa = false;
            notify();
        }
        public void detener() {
            corriendo = false;
            if (pausa) reanudar();

        }
        @Override public void run() {
            corriendo = true;
            while (corriendo) {
                actualizaFisica();
                synchronized (this) {
                    while (pausa) {
                        try {
                            wait();
                        } catch (Exception e) {
                        }
                    }
                }
            }
        }
    }


    @Override public boolean onKeyUp(int codigoTecla, KeyEvent evento) {
        super.onKeyUp(codigoTecla, evento);
// Suponemos que vamos a procesar la pulsación
        boolean procesada = true;
        switch (codigoTecla) {
            case KeyEvent.KEYCODE_DPAD_UP:
                aceleracionNave = 0;
                break;
            case KeyEvent.KEYCODE_DPAD_LEFT:
            case KeyEvent.KEYCODE_DPAD_RIGHT:
                giroNave = 0;
                break;
            default:
// Si estamos aquí, no hay pulsación que nos interese
                procesada = false;
                break;
        }
        return procesada;
    }

    private float mX=0, mY=0;
    private boolean disparo=false;
    @Override
    public boolean onTouchEvent (MotionEvent event) {
        super.onTouchEvent(event);
        float x = event.getX();
        float y = event.getY();
        switch (event.getAction()) {
            case MotionEvent.ACTION_DOWN:
                disparo=true;
                break;
            case MotionEvent.ACTION_MOVE:
                float dx = Math.abs(x - mX);
                float dy = Math.abs(y - mY);
                if (dy<6 && dx>6){
                    giroNave = Math.round((x - mX) / 2);
                    disparo = false;
                } else if (dx<6 && dy>6){
                    aceleracionNave = Math.round((mY - y) / 25);
                    disparo = false;
                }
                break;
            case MotionEvent.ACTION_UP:
                giroNave = 0;
                aceleracionNave = 0;
                if (disparo){
                    activaMisil();
                }
                break;
        }
        mX=x; mY=y;
        return true;
    }

    public void onAccuracyChanged(Sensor sensor, int accuracy) {}
    private boolean hayValorInicial = false;
    private float valorInicial;
    public void onSensorChanged(SensorEvent event) {
        float valor = event.values[1];
        if (!hayValorInicial){
            valorInicial = valor;
            hayValorInicial = true;
        }
        giroNave=(int) (valor-valorInicial)/3 ;
    }

    private void destruyeAsteroide(int i) {
        asteroides.remove(i);

        misilActivo = false;
        puntuacion += 1000;

        //mpExplosion.start();

        soundPool.play(idExplosion, 1, 1, 0, 0, 1);

        if (asteroides.isEmpty()) {
            salir();
        }
    }

    private void activaMisil() {

        misil.setCenX(nave.getCenX());
        misil.setCenY(nave.getCenY());
        misil.setAngulo(nave.getAngulo());
        misil.setIncX(Math.cos(Math.toRadians(misil.getAngulo())) *
                PASO_VELOCIDAD_MISIL);
        misil.setIncY(Math.sin(Math.toRadians(misil.getAngulo())) * PASO_VELOCIDAD_MISIL);
        tiempoMisil = (int) Math.min(this.getWidth() / Math.abs( misil.
                getIncX()), this.getHeight() / Math.abs(misil.getIncY())) - 2;
        misilActivo = true;

        mpDisparo.start();

        soundPool.play(idDisparo, 1, 1, 1, 0, 1);
    }


    @Override
    protected void onSizeChanged(int ancho, int alto,
                                 int
                                         ancho_anter, int alto_anter) {
        super.onSizeChanged(ancho, alto, ancho_anter, alto_anter);
// Una vez que conocemos nuestro ancho y alto.
        for (Grafico asteroide : asteroides) {
            do {
                asteroide.setCenX((int)(Math.random()*ancho));
                asteroide.setCenY((int)(Math.random()*alto));
            }while(asteroide.distancia(nave)<(ancho+alto) / 5);
        }
        nave.setCenX(ancho/2);
        nave.setCenY(alto/2);

        ultimoProceso = System.currentTimeMillis();
        thread.start();
    }
    @Override protected synchronized void onDraw(Canvas canvas) {
        super.onDraw(canvas);
        for (Grafico asteroide: asteroides) {
            asteroide.dibujaGrafico(canvas);
        }
        nave.dibujaGrafico(canvas);

        if (misilActivo) {
            misil.dibujaGrafico(canvas);
        }

    }

    public ThreadJuego getThread() {
        return thread;
    }


    public boolean activarSensores() {
        List<Sensor> listaSensores = sm.getSensorList(Sensor.TYPE_ORIENTATION);
        if (!listaSensores.isEmpty()) {
            Sensor sensorOrientacion = listaSensores.get(0);
            sm.registerListener(this, sensorOrientacion, sm.SENSOR_DELAY_GAME);
            return sensorActivo = true;
        } else
            return sensorActivo;

    }


    public boolean desactivarSensores() {
        if (sensorActivo) {
            sm.unregisterListener(this);
            sensorActivo = false;
        }
        return sensorActivo;
    }

}
